import java.net.*;
import java.io.*;
import java.util.*;



///////////////////////////////////////////////////////////////////////////////
// 
// statistics for a single document lookup
//
///////////////////////////////////////////////////////////////////////////////
final class Stat1
{
    // measured latency (seconds) 
    double lat;

    // measured total time (seconds) 
    double tot;

    // measured document size (bytes) 
    long size;

    // measured bandwidth (bytes/second)
    double band;
    
    // local URL for the retrieved document
    String locURL;
}
