package webppserv;

import java.io.*;
import java.lang.*;

class SysCommandThread extends Thread
{
	String cmd, addr;

	public SysCommandThread(String cmd, String addr){
	  this.cmd = cmd;
	  this.addr = addr;
	}

	public void run(){

	  yield();	// give the caller a chance to go on

	  StringBuffer result = new StringBuffer();
	  String line, hop;				
	  String str = new String(cmd + " " + addr);
			
	  try {
	    Process pr = Runtime.getRuntime().exec(str);
	    InputStream in = pr.getInputStream();
	    BufferedReader din = 
			new BufferedReader(new InputStreamReader(in));
	    while ((line = din.readLine()) != null) {
	      if (!(line.endsWith("\r\n") || line.endsWith("\n")   ||
					  line.endsWith("\r") ))
		line = line + "\n";
	      hop = getHopIP(line);
	      if (result.length() == 0) result.append(hop);
	      else result.append(" " + hop);
	      //System.out.println("trc: " + addr + " : " + line);
	    }	
	  } catch (IOException ioe) {
	    System.out.println("IOException for " + cmd + " " + addr);
	    Webpp.tracerouteDisabled = true;
	  } catch (IllegalArgumentException iae) {
	    System.out.println("IllegalArgumentException for " + cmd +
							 " " + addr);
	  }
	  //System.out.println("Trc: " + result.toString());
	  if (!Webpp.tracerouteDisabled)
	    Webpp.traceroutePaths.put(addr, result.toString());
	  Webpp.tracerouteCount--;
	}

	private String getHopName(String line)
	{
	  String hop, tmp;
	  int pos;

	  pos = line.indexOf(" (");
	  if (pos < 1) {
	    System.out.println("Error in traceroute line: " + line);
	    return null;
	  }
	  tmp = line.substring(0, pos);
	  pos = tmp.lastIndexOf(' ');
	  if (pos < 0) pos = 0;
	  if (pos == 0) hop = tmp;
	  else hop = tmp.substring(pos+1);
	  return hop;
	}

        private String getHopIP(String line)
        {
          String hop;
          int pos1, pos2;

          pos1 = line.indexOf(" (");
          if (pos1 < 1) {
            System.out.println("Error in traceroute line: " + line);
            return null;
          }
          pos2 = line.indexOf(") ");
          if (pos2 < 0) {
	    System.out.println("Error in traceroute line: " + line);
	    return null;
	  }
          hop = line.substring(pos1+2,pos2);
          return hop;
        }


}

